<template>
  <q-card
    :square="!isDesktopPlatform"
    class="column no-wrap col"
  >
    <template v-if="results == null">
      <q-card-section>
        <div
          class="text-body1"
        >
          <translate>No results</translate>.
          <translate>It may be due to an error</translate>.
          <translate>Please verify your fertilization plan inputs and try to compute it again</translate>.
        </div>
      </q-card-section>
    </template>
    <template v-else>
      <q-card-section class="q-pb-none">
        <div
          class="text-body2 text-grey"
          v-if="firstDate != null && lastDate != null"
        >
          <span>{{ fertilizationPlanPlantingMethod.label }}</span>:
          <span style="text-transform: capitalize;">{{ displayDate(firstDate) }} - {{ displayDate(lastDate) }}</span>
        </div>
        <div
          class="row no wrap items-center text-body1 q-mt-sm"
        >
          <q-btn
            flat
            color="grey"
            icon="las la-angle-left"
            @click="selectYesterday"
          />
          <q-btn
            class="col"
            flat
            :label="labelDateSelectorBtn"
            no-caps
            style="text-transform: capitalize;"
          >
            <q-popup-proxy
              @before-show="updateProxy"
              transition-show="scale"
              transition-hide="scale"
            >
              <q-date
                v-model="proxyDate"
                mask="YYYY-MM-DD"
                today-btn
                :options="dateOptions"
              >
                <div class="row items-center justify-end q-gutter-sm">
                  <q-btn
                    label="Cancel"
                    color="primary"
                    flat
                    v-close-popup
                  />
                  <q-btn
                    label="OK"
                    color="primary"
                    flat
                    @click="saveProxy"
                    v-close-popup
                  />
                </div>
              </q-date>
            </q-popup-proxy>
          </q-btn>
          <q-btn
            flat
            color="grey"
            icon="las la-angle-right"
            @click="selectTomorrow"
          />
        </div>
      </q-card-section>
      <q-card-section v-if="displayedResults == null">
        <translate>No results for this date.</translate>
      </q-card-section>
      <q-card-section v-else>
        <div class="q-mb-sm">
          <translate>Day</translate>: {{ displayedResults.day_after_transplanting }}
        </div>
        <div class="bg-grey-2 q-py-sm">
          <div class="row no-wrap center text-center q-mb-sm text-body1">
            <div class="col-6">
              <translate>Irrigation time</translate>
            </div>
            <div class="col-6">
              <translate>N fertilizer</translate>
            </div>
          </div>
          <div class="row no-wrap center text-center">
            <div class="col-6 column">
              <div class="text-body1 text-bold">
                {{ displayedResults.daily_irrigation_time >= 0 ? Number(Number(displayedResults.daily_irrigation_time) * 60 / 100).toFixed(0) : 0 }}
              </div>
              <div>
                <translate translate-context="unit">
                  min
                </translate>
              </div>
              <div class="text-caption text-grey-7 q-mt-sm">
                {{ `${displayedResults.irrigation_requirements_daily_volume >= 0 ? displayedResults.irrigation_requirements_daily_volume : 0}${$pgettext('unit', 'mm')}` }}
              </div>
            </div>
            <div class="col-6 column">
              <div class="text-body1 text-bold">
                {{ displayedResults.daily_n_fertilizer_requirements }}
              </div>
              <div>
                <translate translate-context="unit">
                  kg/ha
                </translate>
              </div>
            </div>
          </div>
        </div>
        <div class="q-mt-md">
          <q-select
            v-model="selectedChart"
            :options="selectChartOptions"
            map-options
            emit-value
            :label="$gettext('Select your chart')"
          />
          <apexchart
            :type="chartDefinition.type"
            :options="chartDefinition.options"
            :series="chartDefinition.series"
            :height="250"
          />
        </div>
      </q-card-section>
    </template>

    <!-- buttons -->
    <slot name="action-buttons" />

    <q-card-section
      v-if="displayActionButtons"
      class="q-mt-auto"
    >
      <q-card-actions
        class="q-pa-none"
        vertical
        align="stretch"
      >
        <q-btn
          color="primary"
          text-color="white"
          :loading="saving"
          @click="onClickSavePlan"
        >
          {{ savePlanButtonLabel }}
        </q-btn>
        <q-btn
          flat
          color="primary"
          @click="$router.back()"
        >
          <translate>Previous</translate>
        </q-btn>
        <q-btn
          flat
          color="primary"
          @click="$router.push({name: 'fertilizationPlans'})"
        >
          <translate>Back to all my plans</translate>
        </q-btn>
      </q-card-actions>
    </q-card-section>
  </q-card>
</template>

<script>
import { defineAsyncComponent } from 'vue'
import { date, colors as quasarColors } from 'quasar'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'

const { getPaletteColor } = quasarColors
const RESULTS_DATE_FORMAT = 'M/D/YYYY'

export default {
  name: 'VegsystResultsCard',
  components: {
    // dynamically import apexchart to avoid bundling it with other vendor libs as it is very large
    apexchart: defineAsyncComponent(() => import('vue-apexcharts'))
  },
  mixins: [PlatformMixin, DateMixin, FertilizationPlanMixin, AlgorithmsMixins],
  props: {
    fertilizationPlanParameters: {
      type: Object,
      required: true
    },
    fertilizationPlanResults: {
      type: [Array, Object],
      required: false,
      default: null
    },
    displayActionButtons: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      selectedDate: new Date(),
      proxyDate: null,
      selectedChart: 'N Quantity',
      selectChartOptions: [
        {
          value: 'Irrigation',
          label: this.$gettext('Irrigation')
        },
        {
          value: 'N Quantity',
          label: this.$pgettext('N: Nitrogen', 'N quantity')
        },
        {
          value: 'N Concentration',
          label: this.$pgettext('Chemical concentration of nitrogen', 'N concentration')
        }
      ]
    }
  },
  computed: {
    chartDefinition () {
      if (this.selectedChart != null && this.results?.length) {
        let colors
        let yAxisTitle
        if (this.selectedChart === 'Irrigation') {
          colors = [getPaletteColor('chart-blue'), getPaletteColor('chart-yellow')]
          yAxisTitle = `${this.$gettext('Irrigation')} (mm/d)`
        } else if (this.selectedChart === 'N Quantity') {
          colors = [getPaletteColor('chart-red'), getPaletteColor('chart-blue-darker'), getPaletteColor('chart-green')]
          yAxisTitle = 'N (kg/ha/d)'
        } else {
          colors = [getPaletteColor('chart-blue-deep')]
          yAxisTitle = 'N (mmol/L/d)'
        }
        const chartTooltipXDisplay = (val) => `${this.$gettext('Day')} ${val}`
        const selectedDateDay = this.displayedResults.day_after_transplanting
        return {
          type: 'line',
          options: {
            annotations: {
              xaxis: [
                {
                  x: selectedDateDay,
                  borderColor: getPaletteColor('chart-dark')
                }
              ]
            },
            chart: {
              id: this.selectedChart,
              type: 'line',
              animations: {
                enabled: true,
                easing: 'easeinout',
                speed: 800
              },
              toolbar: {
                show: false
              }
            },
            colors,
            grid: {
              borderColor: getPaletteColor('grey-3')
            },
            legend: {
              showForSingleSeries: true
            },
            stroke: {
              width: 2,
              curve: 'smooth'
            },
            tooltip: {
              x: {
                formatter: chartTooltipXDisplay
              }
            },
            xaxis: {
              type: 'day',
              categories: this.chartXAxisData,
              // labels: {
              //   format: 'ddd HH',
              //   style: {
              //     colors: '#FFF'
              //   }
              // },
              min: this.chartXAxisData[0],
              max: this.chartXAxisData[this.results.length - 1],
              tickAmount: Math.min(this.results.length / 2, 10),
              title: {
                text: this.$gettext('Day')
              }
            },
            yaxis: {
              min: 0,
              tickAmount: Math.min(this.results.length / 2, 8),
              decimalsInFloat: 2,
              // labels: {
              //   formatter (val, index) { console.log(val, index); return val }
              // },
              title: {
                text: yAxisTitle
              }
            }
          },
          series: this.chartSeries[this.selectedChart]
        }
      } else {
        return null
      }
    },
    chartSeries () {
      if (this.results?.length) {
        const seriesEtc = {
          name: 'ETc',
          data: []
        }
        const seriesIrrigation = {
          name: this.$gettext('Irrigation'),
          data: []
        }
        const seriesNFertilizer = {
          name: this.$gettext('N fertilizer'),
          data: []
        }
        const seriesNUptake = {
          name: this.$gettext('N uptake'),
          data: []
        }
        const seriesSoilNSupply = {
          name: this.$gettext('Soil N supply'),
          data: []
        }
        const seriesNConcentration = {
          name: this.$gettext('N concentration'),
          data: []
        }
        for (let i = 0; i < this.results.length; i++) {
          seriesEtc.data.push(this.results[i].etc)
          seriesIrrigation.data.push(this.results[i].irrigation_requirements_daily_volume >= 0 ? this.results[i].irrigation_requirements_daily_volume : 0)
          seriesNFertilizer.data.push(this.results[i].daily_n_fertilizer_requirements)
          seriesNUptake.data.push(this.results[i].daily_crop_n_uptake)
          seriesSoilNSupply.data.push(this.results[i].daily_soil_mineral_n)
          seriesNConcentration.data.push(this.results[i].average_four_weekly_n_concentration)
        }
        return {
          Irrigation: [
            seriesEtc,
            seriesIrrigation
          ],
          'N Quantity': [
            seriesNFertilizer,
            seriesNUptake,
            seriesSoilNSupply
          ],
          'N Concentration': [
            seriesNConcentration
          ]
        }
      }
      return null
    },
    chartXAxisData () {
      if (this.results?.length) {
        return this.results.map(r => r.day_after_transplanting)
      } else {
        return null
      }
    },
    displayedResults () {
      // first check if selected date is within results dates range
      if (this.results?.length) {
        if (this.results.length === 1) {
          return date.formatDate(this.selectedDate, RESULTS_DATE_FORMAT) === this.firstDate
            ? this.results[0]
            : null
        } else {
          if (date.isBetweenDates(this.selectedDate, this.firstDate, this.lastDate, { onlyDate: true, inclusiveFrom: true, inclusiveTo: true })) {
            // there is a result for the selected date
            const nowResultsFormat = date.formatDate(this.selectedDate, RESULTS_DATE_FORMAT)
            for (let i = 0; i < this.results.length; i++) {
              if (this.results[i].date === nowResultsFormat) {
                // display results
                return this.results[i]
              }
            }
            return null
          } else {
            return null
          }
        }
      } else {
        return null
      }
    },
    fertilizationPlanPlantingMethod () {
      return this.fertilizationPlanParameters.plantingMethod
    },
    firstDate () {
      return this.results?.length ? date.extractDate(this.results[0].date, RESULTS_DATE_FORMAT) : null
    },
    labelDateSelectorBtn () {
      let s = this.displayDate(this.selectedDate)
      const today = (new Date()).toDateString()
      if (today === this.selectedDate.toDateString()) {
        s += ` (${this.$gettext('today')})`
      }
      return s
    },
    lastDate () {
      return this.results?.length ? date.extractDate(this.results[this.results.length - 1].date, RESULTS_DATE_FORMAT) : null
    },
    pageTitle () {
      return this.$gettext('Results')
    },
    pageSubTitle () {
      return 'VegSyst'
    },
    results () {
      return this.fertilizationPlanResults != null ? this.fertilizationPlanResults : this.fertilizationPlanParameters.results
    }
  },
  apollo: {
  },
  methods: {
    dateOptions (date) {
      let condition = true
      if (this.firstDate != null) condition = condition && date >= date.formatDate(this.firstDate, 'YYYY/MM/DD')
      if (this.lastDate != null) condition = condition && date <= date.formatDate(this.lastDate, 'YYYY/MM/DD')
      return condition
    },
    onClickSavePlan () {
      this.savePlan(this.results)
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'vegsystComputePage'
      })
    },
    saveProxy () {
      this.selectedDate = new Date(this.proxyDate)
      // this.getResultsForSelectedDate()
    },
    selectTomorrow () {
      this.selectedDate = date.addToDate(this.selectedDate, { days: 1 })
      // this.getResultsForSelectedDate()
    },
    selectYesterday () {
      this.selectedDate = date.subtractFromDate(this.selectedDate, { days: 1 })
      // this.getResultsForSelectedDate()
    },
    updateProxy () {
      this.proxyDate = date.formatDate(this.selectedDate, 'YYYY-MM-DD')
    }

  }
}
</script>
